
const OCCUPIED = 2,
    PREVIOUSLY = 1,
    EMPTY = 0;

export default function process(state) {
    return state.map(function procRow(row, y) {
        return row.map(function procCells(value, x) {
            const xb = x - 1,
                xa = x + 1,
                yb = y - 1,
                ya = y + 1;

            let livingNeighbours = 0;
            for( let i = yb; i <= ya; i++ ) {
                if( i >= 0 && i < state.size ) {
                    for( let j = xb; j <= xa; j++ ) {
                        if( !(i === y && j === x) && state.get(i).get(j) === 2 ) {
                            if( j >= 0 && j < row.size ) {
                                livingNeighbours += 1;
                            }
                        }
                    }
                }
            }

            if( value === OCCUPIED ) {
                if( livingNeighbours < 2 || livingNeighbours > 3 ) {
                    return PREVIOUSLY;
                }
            }
            else if( livingNeighbours === 3 ) {
                return OCCUPIED;
            }

            return value;
        });
    });
};


